#! /usr/bin/env python

"""Regenerate a MHonArc archive for a given team or all team mailing lists.

Must be run on the Mailman server.
"""

import os
import sys
from os.path import join
from string import Template

BASE_PATH = '/srv/lists.launchpad.net/var/mailman'
BASE_PATH = '/var/tmp/mailman'

CMD_ARGS = (
    '/usr/bin/mhonarc',
    '-dbfile', join(BASE_PATH, 'archives/private/$team_name.mbox/mhonarc.db'),
    '-outdir', join(BASE_PATH, 'mhonarc/$team_name'),
    '--stderr', join(BASE_PATH, 'logs/mhonarc'),
    '--stdout', join(BASE_PATH, 'logs/mhonarc'),
    '-spammode', '-umask 022', '-reconvert',
    '-definevar ML-NAME=$team_name',
    '-rcfile', join(BASE_PATH, 'data/lp-mhonarc-common.mrc'),
    join(BASE_PATH, 'archives/private/$team_name.mbox/$team_name.mbox'),
    )


if len(sys.argv) != 2:
    print 'team name or --all required'
    sys.exit(1)


def run(team_name):
    command = Template(' '.join(CMD_ARGS)).substitute(team_name=team_name)
    print command
    os.system(command)


team_name = sys.argv[1]
if team_name == '--all':
    for team_name in os.listdir(join(BASE_PATH, 'mhonarc')):
        run(team_name)
else:
    run(team_name)
